(function ($) {
  Drupal.behaviors.comment_easy_reply = {
    attach: function (context, settings) {
      var comment_form = $("#edit-comment-body");
      $('.comment-easy-reply-number-link-wrapper', context).once().each(function () {
        var tips = $(this).children('.comment-easy-reply-number-link-tips');
        var link = $(this).children('.comment-easy-reply-number-link');
        if (Drupal.settings.comment_easy_reply != 'undefined'
          && Drupal.settings.comment_easy_reply.replytip_activated) {
          link.hover(function () {
            $('.comment-easy-reply-number-link-tips').hide();
            tips.show();
            Drupal.comment_easy_reply.init_tips(link,tips);
          },
          function (e) {
            var linkY = link.offset().top + link.outerHeight();
            var posY = e.pageY;
            if (posY>linkY) {
              tips.hide();
            }
          });
          tips.hover(function () {
            tips.show();
          },
          function () {
            tips.hide();
          });
        }
        if (Drupal.settings.comment_easy_reply != 'undefined'
          && comment_form.length > 0
          && Drupal.settings.comment_easy_reply.user_can_reply
          && Drupal.settings.comment_easy_reply.reply_from_numlink) {
          link.click(function () {
            var classes = $(this).attr('class').split(/\s+/);
            var commentnumber = 0;
            var definedclass = 'comment-easy-reply-linknum-';
            for (i = 0; i < classes.length; i++) {
               if (classes[i].length > 0 && classes[i].substr(0,definedclass.length) == definedclass) {
                 commentnumber = classes[i].substr(definedclass.length,classes[i].length);
                 break;
               }
            }
            if (commentnumber!='undefined') {
              var newvalue = "@#" + commentnumber + " ";
              Drupal.comment_easy_reply.insertContent(newvalue);
            }
            $('html,body').animate({scrollTop: comment_form.offset().top});
            return false;
          });
        }
        if (Drupal.settings.comment_easy_reply != 'undefined'
          && comment_form.length > 0
          && Drupal.settings.comment_easy_reply.user_can_reply
          && Drupal.settings.comment_easy_reply.replytip_activated) {
          var tips_link = tips.children('a');
          tips_link.click(function () {
            var classes = $(this).parent().attr('class').split(/\s+/);
            var commentnumber = 0;
            var definedclass = 'comment-easy-reply-number-link-tips-';
            for (i = 0; i < classes.length; i++) {
               if (classes[i].length > 0 && classes[i].substr(0,definedclass.length) == definedclass) {
                 commentnumber = classes[i].substr(definedclass.length,classes[i].length);
                 break;
               }
            }
            if (commentnumber!='undefined') {
              var newvalue = "@#" + commentnumber + " ";
              Drupal.comment_easy_reply.insertContent(newvalue);
            }
            $('html,body').animate({scrollTop: comment_form.offset().top});
            return false;
          });
        }
      });
      $('.comment-easy-reply-referrer-link-wrapper', context).once().each(function () {
        var tips = $(this).children('.comment-easy-reply-referrer-link-hover');
        var link = $(this).children('.comment-easy-reply-number-link');
        link.hover(function () {
          $('.comment-easy-reply-number-link-tips').hide();
          tips.show();
          Drupal.comment_easy_reply.init_tips(link,tips);
        },
        function () {
          tips.hide();
        });
        if (Drupal.settings.comment_easy_reply != 'undefined'
          && (Drupal.settings.comment_easy_reply.in_preview
          || Drupal.settings.comment_easy_reply.reply_page)) {
          link.click(function () {
            return false;
          });
        }
      });
      if (Drupal.settings.comment_easy_reply != 'undefined'
        && Drupal.settings.comment_easy_reply.user_can_reply) {
        $('.comment-reply', context).once().each(function () {
          if($(this).hasClass('views-field-comment-easy-reply-replyto-comment')){
            var link = $(this).find('.comment-easy-reply-views-reply-link');
          }
          else {
            var link = $(this).children('a');
          }
          link.click(function () {
            var classes = $(this).attr('class').split(/\s+/);
            var commentnumber = 0;
            var definedclass = 'comment-easy-reply-number-';
            for (i = 0; i < classes.length; i++) {
               if(classes[i].length > 0 && classes[i].substr(0,definedclass.length) == definedclass){
                 commentnumber = classes[i].substr(definedclass.length,classes[i].length);
                 break;
               }
            }
            if (commentnumber != 'undefined') {
              var newvalue = "@#" + commentnumber + " ";
              Drupal.comment_easy_reply.insertContent(newvalue);
            }
            $('html,body').animate({scrollTop: comment_form.offset().top});
            return false;
          });
        });
      }
      if (Drupal.settings && Drupal.settings.views && Drupal.settings.views.ajaxViews) {
        $.each(Drupal.settings.views.ajaxViews, function(i, settings) {
          var selector = '.view-dom-id-' + settings.view_dom_id;
          var $comment_easy_reply_view = $(selector);
          $comment_easy_reply_view.find('.comment-easy-reply-number-link').bind('click', function() {
            return false;
          });
        });
      }
    }
  };
  Drupal.comment_easy_reply = {
    insertContent: function(newvalue){
      var textareaid = $('#edit-comment-body textarea').attr('id');
      // WYSIWYG support.
      if (Drupal.wysiwyg && Drupal.wysiwyg.activeId) {
        Drupal.wysiwyg.instances[Drupal.wysiwyg.activeId].insert(newvalue)
      }
      // CKeditor module support.
      else if (typeof(CKEDITOR) != 'undefined' && CKEDITOR.instances[textareaid]) {
        CKEDITOR.instances[textareaid].insertHtml(newvalue);
      }
      // No editor found, go for plain textarea.
      else {
        var editor = document.getElementById(textareaid);
        var oldvalue = editor.value;
        if (document.selection) {
                  editor.focus();
                  sel = document.selection.createRange();
                  sel.text = newvalue;
                  editor.focus();
        }
        else if (editor.selectionStart || editor.selectionStart == '0') {
          var startPos = editor.selectionStart;
          var endPos = editor.selectionEnd;
          var scrollTop = editor.scrollTop;
          editor.value = editor.value.substring(0, startPos)+newvalue+editor.value.substring(endPos,editor.value.length);
          editor.focus();
          editor.selectionStart = startPos + newvalue.length;
          editor.selectionEnd = startPos + newvalue.length;
          editor.scrollTop = scrollTop;
        } else {
          editor.value += myValue;
          editor.focus();
        }
      }
    },
    init_tips: function(link,tips){
      if ($(window).width() < tips.outerWidth() * 1.5) {
        tips.css('max-width', $(window).width() / 2);
      }
      else {
        tips.css({'min-width':'200px', 'max-width':'340px'});
      }
      var pos_left = link.offset().left + (link.outerWidth() / 2) - (tips.outerWidth() / 2);
      var pos_top = link.offset().top - tips.outerHeight();
      if (pos_left < 0) {
        pos_left = link.offset().left + link.outerWidth() / 2 - 20;
      }
      if (pos_left + tips.outerWidth() > $(window).width()) {
        pos_left = link.offset().left - tips.outerWidth() + link.outerWidth() / 2 + 20;
      }
      else {
        if (pos_top < 0) {
          var pos_top = link.offset().top + link.outerHeight();
        }
        tips.css({'left': pos_left, 'top': pos_top-20}).offset({'left': pos_left, 'top': pos_top-20});
      }
    }
  };
})(jQuery);
